// MatrixGridView.cpp : implementation of the CMatrixGridView class
//

#include "stdafx.h"
#include "MatrixGrid.h"
#include "Customize.h"

#include "MatrixGridDoc.h"
#include "MatrixGridView.h"
#include "Temp.h"
#include "memory.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView

IMPLEMENT_DYNCREATE(CMatrixGridView, CScrollView)

BEGIN_MESSAGE_MAP(CMatrixGridView, CScrollView)
	//{{AFX_MSG_MAP(CMatrixGridView)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_COMMAND(ID_EDIT_CUSTOMIZE, OnEditCustomize)
	ON_COMMAND(ID_ZOOM_25, OnZoom25)
	ON_COMMAND(ID_ZOOM_50, OnZoom50)
	ON_COMMAND(ID_ZOOM_100, OnZoom100)
	ON_COMMAND(ID_ZOOM_200, OnZoom200)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_POPUP_COLOR, OnPopupColor)
	ON_WM_RBUTTONDOWN()
	ON_COMMAND(ID_POPUP_CUT, OnPopupCut)
	ON_COMMAND(ID_POPUP_COPY, OnPopupCopy)
	ON_COMMAND(ID_POPUP_PASTE, OnPopupPaste)
	ON_COMMAND(ID_EDIT_CUT, OnPopupCut)
	ON_COMMAND(ID_EDIT_PASTE, OnPopupPaste)
	ON_COMMAND(ID_EDIT_COPY, OnPopupCopy)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView construction/destruction

CMatrixGridView::CMatrixGridView()
{
		m_iColIndex=1;
		m_iRowIndex=1;
	m_uRegisterClipboardFormat=RegisterClipboardFormat("MatrixGrid");
	SCODE scode=::OleInitialize(NULL);
	if(FAILED(scode))
	{
		MessageBox("Operation failure");
	}
}

CMatrixGridView::~CMatrixGridView()
{
}

BOOL CMatrixGridView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView drawing

void CMatrixGridView::OnDraw(CDC* pDC)
{
	CMatrixGridDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDC->SetBkMode(TRANSPARENT);
	InitializeCell();
	FillColor(pDC);
	SetScrollPosition();
	DrawGrid(pDC);
}

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView printing

BOOL CMatrixGridView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CMatrixGridView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CMatrixGridView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView diagnostics

#ifdef _DEBUG
void CMatrixGridView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CMatrixGridView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CMatrixGridDoc* CMatrixGridView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMatrixGridDoc)));
	return (CMatrixGridDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMatrixGridView message handlers

void CMatrixGridView::DrawGrid(CDC *pDC)
{  
	CMatrixGridDoc *pDoc=GetDocument();
    int iIndex;
	for(iIndex=0;iIndex<=pDoc->m_iColoums;iIndex++)
	{
		pDC->MoveTo(pDoc->m_iXoffset+(iIndex*pDoc->m_iWidth),pDoc->m_iYoffset);
		pDC->LineTo(pDoc->m_iXoffset+(iIndex*pDoc->m_iWidth),pDoc->m_iYoffset+(pDoc->m_iHeight*pDoc->m_iRow));		
	}
	for(iIndex=0;iIndex<=pDoc->m_iRow;iIndex++)
	{
		pDC->MoveTo(pDoc->m_iXoffset,pDoc->m_iYoffset+(iIndex*pDoc->m_iHeight));
		pDC->LineTo(pDoc->m_iXoffset+(pDoc->m_iWidth*pDoc->m_iColoums),pDoc->m_iYoffset+(iIndex*pDoc->m_iHeight));
	}
}

void CMatrixGridView::InitializeCell()
{
	CMatrixGridDoc *pDoc=GetDocument();
	for(int iRowIndex=0;iRowIndex<pDoc->m_iRow;iRowIndex++)
	{
		for(int iColIndex=0;iColIndex<pDoc->m_iColoums;iColIndex++)
		{
			pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.SetRect(0,0,pDoc->m_iWidth,pDoc->m_iHeight);
			pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.OffsetRect(pDoc->m_iXoffset+(pDoc->m_iWidth*iColIndex),pDoc->m_iYoffset+(pDoc->m_iHeight*iRowIndex));
        }
	}
}

void CMatrixGridView::FillColor(CDC *pDC)
{   
    CMatrixGridDoc *pDoc=GetDocument();
	ASSERT_VALID(pDoc);

	CBrush WhiteBrush(RGB(255,255,255));
	CBrush RedBrush(RGB(255,0,0));
	CBrush BlueBrush(RGB(0,0,255));
	CBrush GreenBrush(RGB(0,255,0));
		for(int iRowIndex=0;iRowIndex<pDoc->m_iRow;iRowIndex++)
		for(int iColIndex=0;iColIndex<pDoc->m_iColoums;iColIndex++)
		{   
			switch(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_iColor)
			{
			case WHITE:
				{
					pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect,&WhiteBrush);
					break;
				}
			case RED:
				{
					pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect,&RedBrush);
					break;
				}
			
			case GREEN:
				{
					pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect,&GreenBrush);
					break;
				}
			case BLUE:
				{
					pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect,&BlueBrush);
					break;
				}
			case CUSTOM:
				{  
					CBrush CustomBrush(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_cColor);
					pDC->FillRect(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect,&CustomBrush);
					break;
				}
			}
			pDC->DrawText(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_strText,pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect,DT_LEFT);
		}
}

void CMatrixGridView::OnLButtonDown(UINT nFlags, CPoint point) 
{
 	CMatrixGridDoc *pDoc=GetDocument();
	CUndo Undo;
	CPoint point1;

	DeleteWindow();
	point1=GetScrollPosition();
	point+=point1;
	for(int iRowIndex=0;iRowIndex<pDoc->m_iRow;iRowIndex++)
	{
		for(int iColIndex=0;iColIndex<pDoc->m_iColoums;iColIndex++)
		{   
		    if(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.PtInRect(point))
			{
				m_iColIndex=iColIndex;
				m_iRowIndex=iRowIndex;

				Undo.m_iCol=iColIndex;
				Undo.m_iRow=iRowIndex;
				Undo.m_iColor=pDoc->m_arrCellArray[iRowIndex][iColIndex].m_iColor;
				Undo.m_strContents=pDoc->m_arrCellArray[iRowIndex][iColIndex].m_strText;
				
				pDoc->m_arrUndo.Add(Undo);

				if(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_iColor>BLUE )
				{
					pDoc->m_arrCellArray[iRowIndex][iColIndex].m_iColor=WHITE;
				}
				else
				{
					pDoc->m_arrCellArray[iRowIndex][iColIndex].m_iColor++;
				}
			}
		}	
	}
	Invalidate();
   
CScrollView::OnLButtonDown(nFlags, point);	
}

void CMatrixGridView::OnLButtonDblClk(UINT nFlags, CPoint point) 
{
    CMatrixGridDoc *pDoc=GetDocument();
	CPoint point1;

	point1=GetScrollPosition();
	for(int iRowIndex=0;iRowIndex<pDoc->m_iRow;iRowIndex++)
	{
		for(int iColIndex=0;iColIndex<pDoc->m_iColoums;iColIndex++)
		{  
			pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.SetRect(1,1,pDoc->m_iWidth,pDoc->m_iHeight);
			pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.OffsetRect(pDoc->m_iXoffset+(pDoc->m_iWidth*iColIndex)-point1.x,pDoc->m_iYoffset+(pDoc->m_iHeight*iRowIndex)-point1.y);
			if(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.PtInRect(point))
			{
				pDoc->m_edit=new CEdit;
				m_iSelRow=iRowIndex;
				m_iSelCol=iColIndex;
				pDoc->m_edit->Create(ES_MULTILINE | WS_CHILD | WS_VISIBLE ,pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect,this,1);
				pDoc->m_edit->SetFocus();
				pDoc->m_edit->SetWindowText(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_strText);
			}
		}
	}

	CScrollView::OnLButtonDblClk(nFlags, point);
}

void CMatrixGridView::DeleteWindow()
{
	CMatrixGridDoc *pDoc=GetDocument();
	if(pDoc->m_edit)
	{
		pDoc->m_edit->GetWindowText(pDoc->m_arrCellArray[m_iSelRow][m_iSelCol].m_strText);
		delete(pDoc->m_edit);
		pDoc->m_edit=NULL;
 	}
}

void CMatrixGridView::OnEditUndo() 
{
	int iArrSize;
	CUndo Undo;
	CPoint point;
	CMatrixGridDoc *pDoc=GetDocument();
	
	DeleteWindow();
	iArrSize=pDoc->m_arrUndo.GetSize();
	if(iArrSize!=0)
	{
		Undo=pDoc->m_arrUndo.GetAt(iArrSize-1);
		pDoc->m_arrCellArray[Undo.m_iRow][Undo.m_iCol].m_iColor=Undo.m_iColor;
		pDoc->m_arrCellArray[Undo.m_iRow][Undo.m_iCol].m_strText=Undo.m_strContents;
		pDoc->m_arrUndo.RemoveAt(iArrSize-1);
    	Invalidate();
	}
	
}

void CMatrixGridView::OnEditCustomize() 
{   
	DeleteWindow();
	CMatrixGridDoc *pDoc=GetDocument();
	CCustomize Customize;
	CTemp temp;
	
	Customize.m_iCol=pDoc->m_iColoums;
	Customize.m_iRow=pDoc->m_iRow;
	Customize.m_iHeight=pDoc->m_iHeight;
	Customize.m_iWidth=pDoc->m_iWidth;

	PossionBegin:

	if(Customize.DoModal()==IDOK)
	{    
		if(Customize.m_iCol==0 || Customize.m_iRow==0 || Customize.m_iHeight==0 || Customize.m_iWidth==0)
		{
			goto PossionBegin;
		}
		 pDoc->m_iColoums=Customize.m_iCol;
		 pDoc->m_iRow=Customize.m_iRow;
         pDoc->m_iHeight=Customize.m_iHeight;
		 pDoc->m_iWidth=Customize.m_iWidth;

		pDoc->m_arrZoom.RemoveAll();
		temp.m_iHeight=pDoc->m_iHeight;
		temp.m_iWidth=pDoc->m_iWidth;
		pDoc->m_arrZoom.Add(temp);
	}
	else
	{
		Customize.m_iCol=pDoc->m_iColoums;
		Customize.m_iRow=pDoc->m_iRow;
		Customize.m_iHeight=pDoc->m_iHeight;
		Customize.m_iWidth=pDoc->m_iWidth;
	}
	Invalidate();
}

void CMatrixGridView::OnZoom25() 
{      
		CMatrixGridDoc *pDoc=GetDocument();
		DeleteWindow();
		CTemp temp;
		if(pDoc->m_arrZoom.GetSize())
		{
			temp=pDoc->m_arrZoom.GetAt(0);
			pDoc->m_iHeight=temp.m_iHeight*.25;
			pDoc->m_iWidth=temp.m_iWidth*.25;
			SetScrollPosition();
			Invalidate();
		}
		else
		{
			pDoc->m_iHeight=HEIGHT*.25;
			pDoc->m_iWidth=WIDTH*.25;
			SetScrollPosition();
			Invalidate();
		}
}

void CMatrixGridView::OnZoom50() 
{
		CMatrixGridDoc *pDoc=GetDocument();
		DeleteWindow();
		CTemp temp;
		if(pDoc->m_arrZoom.GetSize())
		{
			temp=pDoc->m_arrZoom.GetAt(0);
			pDoc->m_iHeight=temp.m_iHeight*.50;
			pDoc->m_iWidth=temp.m_iWidth*.50;
			SetScrollPosition();
			Invalidate();
		}
		else
		{
			pDoc->m_iHeight=HEIGHT*.50;
			pDoc->m_iWidth=WIDTH*.50;
			SetScrollPosition();
			Invalidate();
		}
}

void CMatrixGridView::OnZoom100() 
{
		CMatrixGridDoc *pDoc=GetDocument();
		DeleteWindow();
		CTemp temp;
		if(pDoc->m_arrZoom.GetSize())
		{
			temp=pDoc->m_arrZoom.GetAt(0);
			pDoc->m_iHeight=temp.m_iHeight*1;
			pDoc->m_iWidth=temp.m_iWidth*1;
			SetScrollPosition();
			Invalidate();
		}
		else
		{
			pDoc->m_iHeight=HEIGHT*1;
			pDoc->m_iWidth=WIDTH*1;
			SetScrollPosition();
			Invalidate();
		}
}

void CMatrixGridView::OnZoom200() 
{
		DeleteWindow();
		CMatrixGridDoc *pDoc=GetDocument();
		CTemp temp;
		SetScrollPosition();
		if(pDoc->m_arrZoom.GetSize())
		{
			temp=pDoc->m_arrZoom.GetAt(0);
			pDoc->m_iHeight=temp.m_iHeight*2;
			pDoc->m_iWidth=temp.m_iWidth*2;
			SetScrollPosition();
			Invalidate();
		}
		else
		{
			pDoc->m_iHeight=HEIGHT*2;
			pDoc->m_iWidth=WIDTH*2;
			SetScrollPosition();
			Invalidate();
		}
}

void CMatrixGridView::SetScrollPosition()
{
	CMatrixGridDoc *pDoc=GetDocument();
	int iHorizontalPosition=pDoc->m_iXoffset+pDoc->m_iColoums*pDoc->m_iWidth+100;
	int iVerticalPosition=pDoc->m_iYoffset+pDoc->m_iRow*pDoc->m_iHeight+100;
	SetScrollSizes(MM_TEXT,CSize(iHorizontalPosition,iVerticalPosition));
}

void CMatrixGridView::OnInitialUpdate() 
{
	CScrollView::OnInitialUpdate();
	SetScrollPosition();
}

void CMatrixGridView::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
		
	CScrollView::CalcWindowRect(lpClientRect, nAdjustType);
}

void CMatrixGridView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
	
	CMatrixGridDoc *pDoc=GetDocument();
	DeleteWindow();
	ScreenToClient(&point);
	for(int iRowIndex=0;iRowIndex<pDoc->m_iRow;iRowIndex++)
	{
		for(int iColIndex=0;iColIndex<pDoc->m_iColoums;iColIndex++)
		{   
		    if(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.PtInRect(point))
			{
			     CMenu Menu;
				 Menu.LoadMenu(IDR_MENU_POPUP);
				 CMenu *pMenu =Menu.GetSubMenu(0);
				 pMenu->TrackPopupMenu(TPM_RIGHTALIGN|TPM_RIGHTBUTTON,point.x,point.y,this,pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect);
			}
		}
	}

}

void CMatrixGridView::OnPopupColor() 
{
	CColorDialog ColorDialog;
   	CMatrixGridDoc *pDoc=GetDocument();
	
    if(ColorDialog.DoModal()==IDOK)
	{
		pDoc->m_cColor=ColorDialog.GetColor();

		 pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_cColor=pDoc->m_cColor;
		pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_iColor=CUSTOM;
			
	}
	Invalidate();


}

void CMatrixGridView::OnRButtonDown(UINT nFlags, CPoint point) 
{
	CMatrixGridDoc *pDoc=GetDocument();
	CPoint point1;
	point1=GetScrollPosition();
	point=point+point1;

	for(int iRowIndex=0;iRowIndex<pDoc->m_iRow;iRowIndex++)
	{
		for(int iColIndex=0;iColIndex<pDoc->m_iColoums;iColIndex++)
		{   
		    if(pDoc->m_arrCellArray[iRowIndex][iColIndex].m_Rect.PtInRect(point))
			{
				m_iColIndex=iColIndex;
				m_iRowIndex=iRowIndex;
			}
		}
	}
	
	CScrollView::OnRButtonDown(nFlags, point);
}

void CMatrixGridView::OnPopupCut() 
{
	CMatrixGridDoc* pDoc=GetDocument();
	CopyData();
	pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_iColor=0;
	pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_strText="";
	Invalidate();
}

void CMatrixGridView::OnPopupCopy() 
{
    CopyData();
	Invalidate();
}

void CMatrixGridView::OnPopupPaste() 
{
	CMatrixGridDoc* pDoc = GetDocument();
	COleDataObject Object;
	CString strTemp;
	CString strText;
	int iColour;

	if(!Object.AttachClipboard())
	{
		return;
	}
	if(!Object.IsDataAvailable(m_uRegisterClipboardFormat))
	{
		return;
	}
	HGLOBAL hD=Object.GetGlobalData(m_uRegisterClipboardFormat);
	CMemFile memFile((BYTE*)::GlobalLock(hD),::GlobalSize(hD));
	char *cBuffer=new char[GlobalSize(hD)];
	memFile.Read(cBuffer,GlobalSize(hD));
	strTemp=cBuffer;
	strText=strTemp.Left(strTemp.Find("\n"));
	iColour=atoi(strTemp.Mid(strTemp.Find("\n")+1));
	pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_iColor=iColour;
	pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_strText=strText;
	Invalidate();
	
}

void CMatrixGridView::CopyData()
{
	CString strClipBoard;
	CMatrixGridDoc* pDoc=GetDocument();
	
	strClipBoard.Format("%s\n%d",pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_strText,pDoc->m_arrCellArray[m_iRowIndex][m_iColIndex].m_iColor);
	DWORD dwLength=strClipBoard.GetLength();
	HGLOBAL hData=::GlobalAlloc(GMEM_SHARE|GMEM_MOVEABLE|GMEM_ZEROINIT,dwLength);
	void* data=::GlobalLock(hData);
	memcpy(data,(LPCSTR)strClipBoard,dwLength);
	if(!hData)
	{
		return;
	}
	COleDataSource *pSource=new COleDataSource();
	pSource->CacheGlobalData(m_uRegisterClipboardFormat,hData);
	pSource->SetClipboard();


}
